/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2020                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef TEST_WIDGET_H
#define TEST_WIDGET_H
#include <QtGui>
#include <QLabel>
#include <QWidget>
#include <QProgressBar>
#include "PerformanceTest.h"



namespace advisor
{
class CubeTestWidget : public QObject
{
    Q_OBJECT

private:

    PerformanceTest * test;
    QProgressBar* value;
    QLabel*       name;
    QLabel*       value_text;
    QLabel*       value_as_number;
    QString       comment;
    QString*      howToMeasure;
    bool          calculated;

    QString
    getValueText( double );




private slots:


signals:
    void
    showComment( QString& );

    void
    hideComment();

public:
    CubeTestWidget( PerformanceTest* _t );

    virtual
    ~CubeTestWidget()
    {
    }

    void
    apply();

    void
    calculating( );
    
    void 
    setCalculating( const bool v)
    {
        calculated = v;
    }
    
    void
    updateCalculation();

    QLabel*
    getName()
    {
        return name;
    }



    QLabel*
    getValueText()
    {
        return value_text;
    }

    QLabel*
    getValue()
    {
        return value_as_number;
    }


    QProgressBar*
    getProgressBar()
    {
        return value;
    }

    inline
    bool
    isActive()
    {
        return test->isActive();
    }

    inline
    PerformanceTest*
    getPerformanceTest() const
    {
        return test;
    }
};
};

#endif // ADVISER_RATING_WIDGET_H
