/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2018                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef BRANC_PREDICTION_TEST_H
#define BRANC_PREDICTION_TEST_H

#include <string>
#include "PerformanceTest.h"

namespace advisor
{
class BranchPredictionPerformanceTest : public PerformanceTest
{
private:
    cube::Metric*      branch_prediction;
    static std::string br_not_measured;
protected:

    void
    applyCnode( const cube::list_of_cnodes& cnodes  );

    void
    applyCnode( const cube::Cnode*             cnode,
                const cube::CalculationFlavour cnf = cube::CUBE_CALCULATE_INCLUSIVE );


    virtual
    const std::string&
    getCommentText() const;

    inline
    virtual
    const
    QString
    getHelpUrl()
    {
        return ( isActive() ) ?
               QString::fromStdString( "BranchPredictionTest" ) :
               QString::fromStdString( "MissingBranchPredictionTest" );
    }



public:
    BranchPredictionPerformanceTest( cube::CubeProxy* );

    virtual
    ~BranchPredictionPerformanceTest()
    {
    };
// ------ overview tests ---------

    bool
    isActive() const;

    bool
    isIssue() const;
};
};
#endif // ADVISER_RATING_WIDGET_H
