/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2018                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef COMPUTATION_LOAD_BALANCE_TEST_H
#define COMPUTATION_LOAD_BALANCE_TEST_H

#include <string>
#include "PerformanceTest.h"


namespace advisor
{
class ComputationLoadBalanceTest : public PerformanceTest
{
private:
    cube::Metric* comp_norm_imbalance;
protected:

    void
    applyCnode( const cube::list_of_cnodes& cnodes   );

    void
    applyCnode( const cube::Cnode*             cnode,
                const cube::CalculationFlavour cnf = cube::CUBE_CALCULATE_INCLUSIVE );

    virtual
    const std::string&
    getCommentText() const;

    inline
    const
    QString
    getHelpUrl()
    {
        return ( isActive() ) ?
               QString::fromStdString( "ComputationLoadBalanceTest" ) :
               QString::fromStdString( "MissingComputationLoadBalanceTest" );
    }

public:
    ComputationLoadBalanceTest( cube::CubeProxy* );

    virtual
    ~ComputationLoadBalanceTest()
    {
    };
// ------ overview tests ---------

    bool
    isActive() const;

    bool
    isIssue() const;
};
};

#endif // ADVISER_RATING_WIDGET_H
