/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2015-2018                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#ifndef IO_OVERHEAD_TEST_H
#define IO_OVERHEAD_TEST_H

#include <string>
#include "PerformanceTest.h"


namespace advisor
{
class IOOverheadTest : public PerformanceTest
{
protected:

    void
    applyCnode( const cube::list_of_cnodes& cnodes   );

    void
    applyCnode( const cube::Cnode*             cnode,
                const cube::CalculationFlavour cnf = cube::CUBE_CALCULATE_INCLUSIVE );

    virtual
    const std::string&
    getCommentText() const;

    inline
    virtual
    const
    QString
    getHelpUrl()
    {
        return ( isActive() ) ?
               QString::fromStdString( "IOOverheadTest" ) :
               QString::fromStdString( "MissingIOOverheadTest" );
    }

public:
    IOOverheadTest( cube::CubeProxy* );

// ------ overview tests ---------

    bool
    isActive() const;

    bool
    isIssue() const;
};
};

#endif // ADVISER_RATING_WIDGET_H
